diff -ur --unidirectional-new-file /usr/src/usr.sbin/inetd/inetd.c /usr/src-new/usr.sbin/inetd/inetd.c
--- /usr/src/usr.sbin/inetd/inetd.c	2006-01-13 14:26:46.000000000 -0600
+++ /usr/src-new/usr.sbin/inetd/inetd.c	2006-06-20 11:11:04.000000000 -0500
@@ -1974,527 +1707,827 @@
 		int c;
 
 		c = getc(fconfig);
-		ungetc(c, fconfig);
+		(void) ungetc(c, fconfig);
 		if (c == ' ' || c == '\t')
 			if ((cp = nextline(fconfig)))
 				goto again;
-		*cpp = (char *)0;
-		return ((char *)0);
+		*cpp = NULL;
+		return (NULL);
 	}
-	if (*cp == '"' || *cp == '\'')
-		quote = *cp++;
 	start = cp;
-	if (quote)
-		while (*cp && *cp != quote)
-			cp++;
-	else
-		while (*cp && *cp != ' ' && *cp != '\t')
+	quote = '\0';
+	while (*cp && (quote || (*cp != ' ' && *cp != '\t'))) {
+		if (*cp == '\'' || *cp == '"') {
+			if (quote && *cp != quote)
+				cp++;
+			else {
+				if (quote)
+					quote = '\0';
+				else
+					quote = *cp;
+				memmove(cp, cp+1, strlen(cp));
+			}
+		} else
 			cp++;
+	}
 	if (*cp != '\0')
 		*cp++ = '\0';
 	*cpp = cp;
 	return (start);
 }
 
-char *
+static char *
 nextline(FILE *fd)
 {
 	char *cp;
 
 	if (fgets(line, sizeof (line), fd) == NULL)
-		return ((char *)0);
+		return (NULL);
 	cp = strchr(line, '\n');
 	if (cp)
 		*cp = '\0';
 	return (line);
 }
 
-char *
-newstr(const char *cp)
+static char *
+newstr(char *cp)
 {
-	char *cr;
-
-	if ((cr = strdup(cp != NULL ? cp : "")))
-		return (cr);
+	if ((cp = strdup((cp != NULL) ? cp : "")) != NULL)
+		return (cp);
 	syslog(LOG_ERR, "strdup: %m");
-	exit(EX_OSERR);
+	exit(1);
 }
 
-void
-inetd_setproctitle(const char *a, int s)
+static void
+inetd_setproctitle(char *a, int s)
 {
 	socklen_t size;
 	struct sockaddr_storage ss;
-	char buf[80], pbuf[INET6_ADDRSTRLEN];
+	char hbuf[NI_MAXHOST], *hp;
 
 	size = sizeof(ss);
 	if (getpeername(s, (struct sockaddr *)&ss, &size) == 0) {
-		getnameinfo((struct sockaddr *)&ss, size, pbuf, sizeof(pbuf),
-			    NULL, 0, NI_NUMERICHOST|NI_WITHSCOPEID);
-		sprintf(buf, "%s [%s]", a, pbuf);
+		if (getnameinfo((struct sockaddr *)&ss, size, hp = hbuf,
+		    sizeof(hbuf), NULL, 0, niflags) != 0)
+			hp = "?";
+		setproctitle("-%s [%s]", a, hp);
 	} else
-		sprintf(buf, "%s", a);
-	setproctitle("%s", buf);
+		setproctitle("-%s", a);
 }
 
-int
-check_loop(const struct sockaddr *sa, const struct servtab *sep)
+static void
+bump_nofile(void)
 {
-	struct servtab *se2;
-	char pname[INET6_ADDRSTRLEN];
+#ifdef RLIMIT_NOFILE
 
-	for (se2 = servtab; se2; se2 = se2->se_next) {
-		if (!se2->se_bi || se2->se_socktype != SOCK_DGRAM)
-			continue;
+#define FD_CHUNK	32
 
-		switch (se2->se_family) {
-		case AF_INET:
-			if (((const struct sockaddr_in *)sa)->sin_port ==
-			    se2->se_ctrladdr4.sin_port)
-				goto isloop;
-			continue;
-#ifdef INET6
-		case AF_INET6:
-			if (((const struct sockaddr_in *)sa)->sin_port ==
-			    se2->se_ctrladdr4.sin_port)
-				goto isloop;
-			continue;
-#endif
-		default:
-			continue;
-		}
-	isloop:
-		getnameinfo(sa, sa->sa_len, pname, sizeof(pname), NULL, 0,
-			    NI_NUMERICHOST|NI_WITHSCOPEID);
-		syslog(LOG_WARNING, "%s/%s:%s/%s loop request REFUSED from %s",
-		       sep->se_service, sep->se_proto,
-		       se2->se_service, se2->se_proto,
-		       pname);
-		return 1;
+	struct rlimit rl;
+
+	if (getrlimit(RLIMIT_NOFILE, &rl) < 0) {
+		syslog(LOG_ERR, "getrlimit: %m");
+		return;
+	}
+	rl.rlim_cur = MIN(rl.rlim_max, rl.rlim_cur + FD_CHUNK);
+	if (rl.rlim_cur <= rlim_ofile_cur) {
+		syslog(LOG_ERR,
+		    "bump_nofile: cannot extend file limit, max = %d",
+		    (int)rl.rlim_cur);
+		return;
 	}
-	return 0;
+
+	if (setrlimit(RLIMIT_NOFILE, &rl) < 0) {
+		syslog(LOG_ERR, "setrlimit: %m");
+		return;
+	}
+
+	rlim_ofile_cur = rl.rlim_cur;
+	return;
+
+#else
+	syslog(LOG_ERR, "bump_nofile: cannot extend file limit");
+	return;
+#endif
 }
 
 /*
- * print_service:
- *	Dump relevant information to stderr
+ * Internet services provided internally by inetd:
  */
-void
-print_service(const char *action, const struct servtab *sep)
+#define	BUFSIZE	4096
+
+/* ARGSUSED */
+static void
+echo_stream(int s, struct servtab *sep)	/* Echo service -- echo data back */
 {
-	fprintf(stderr,
-	    "%s: %s proto=%s accept=%d max=%d user=%s group=%s"
-#ifdef LOGIN_CAP
-	    "class=%s"
-#endif
-	    " builtin=%p server=%s"
-#ifdef IPSEC
-	    " policy=\"%s\""
-#endif
-	    "\n",
-	    action, sep->se_service, sep->se_proto,
-	    sep->se_accept, sep->se_maxchild, sep->se_user, sep->se_group,
-#ifdef LOGIN_CAP
-	    sep->se_class,
-#endif
-	    (void *) sep->se_bi, sep->se_server
-#ifdef IPSEC
-	    , (sep->se_policy ? sep->se_policy : "")
-#endif
-	    );
+	char buffer[BUFSIZE];
+	int i;
+
+	inetd_setproctitle(sep->se_service, s);
+	while ((i = read(s, buffer, sizeof(buffer))) > 0 &&
+	    write(s, buffer, i) > 0)
+		;
 }
 
-#define CPMHSIZE	256
-#define CPMHMASK	(CPMHSIZE-1)
-#define CHTGRAN		10
-#define CHTSIZE		6
+/* ARGSUSED */
+static void
+echo_dg(int s, struct servtab *sep)	/* Echo service -- echo data back */
+{
+	char buffer[BUFSIZE];
+	int i;
+	socklen_t size;
+	struct sockaddr_storage ss;
+	struct sockaddr *sa;
 
-typedef struct CTime {
-	unsigned long 	ct_Ticks;
-	int		ct_Count;
-} CTime;
+	sa = (struct sockaddr *)&ss;
+	size = sizeof(ss);
+	if ((i = recvfrom(s, buffer, sizeof(buffer), 0, sa, &size)) < 0)
+		return;
+	if (port_good_dg(sa))
+		(void) sendto(s, buffer, i, 0, sa, size);
+}
 
-typedef struct CHash {
-	union {
-		struct in_addr	c4_Addr;
-		struct in6_addr	c6_Addr;
-	} cu_Addr;
-#define	ch_Addr4	cu_Addr.c4_Addr
-#define	ch_Addr6	cu_Addr.c6_Addr
-	int		ch_Family;
-	time_t		ch_LTime;
-	char		*ch_Service;
-	CTime		ch_Times[CHTSIZE];
-} CHash;
+/* ARGSUSED */
+static void
+discard_stream(int s, struct servtab *sep) /* Discard service -- ignore data */
+{
+	char buffer[BUFSIZE];
 
-CHash	CHashAry[CPMHSIZE];
+	inetd_setproctitle(sep->se_service, s);
+	while ((errno = 0, read(s, buffer, sizeof(buffer)) > 0) ||
+			errno == EINTR)
+		;
+}
 
-int
-cpmip(const struct servtab *sep, int ctrl)
+/* ARGSUSED */
+static void
+discard_dg(int s, struct servtab *sep)	/* Discard service -- ignore data */
+	
 {
-	struct sockaddr_storage rss;
-	socklen_t rssLen = sizeof(rss);
-	int r = 0;
+	char buffer[BUFSIZE];
 
-	/*
-	 * If getpeername() fails, just let it through (if logging is
-	 * enabled the condition is caught elsewhere)
-	 */
+	(void) read(s, buffer, sizeof(buffer));
+}
 
-	if (sep->se_maxcpm > 0 && 
-	    getpeername(ctrl, (struct sockaddr *)&rss, &rssLen) == 0 ) {
-		time_t t = time(NULL);
-		int hv = 0xABC3D20F;
-		int i;
-		int cnt = 0;
-		CHash *chBest = NULL;
-		unsigned int ticks = t / CHTGRAN;
-		struct sockaddr_in *sin4;
-#ifdef INET6
-		struct sockaddr_in6 *sin6;
-#endif
+#include <ctype.h>
+#define LINESIZ 72
+char ring[128];
+char *endring;
 
-		sin4 = (struct sockaddr_in *)&rss;
-#ifdef INET6
-		sin6 = (struct sockaddr_in6 *)&rss;
-#endif
-		{
-			char *p;
-			int addrlen;
+static void
+initring(void)
+{
+	int i;
 
-			switch (rss.ss_family) {
-			case AF_INET:
-				p = (char *)&sin4->sin_addr;
-				addrlen = sizeof(struct in_addr);
-				break;
-#ifdef INET6
-			case AF_INET6:
-				p = (char *)&sin6->sin6_addr;
-				addrlen = sizeof(struct in6_addr);
-				break;
-#endif
-			default:
-				/* should not happen */
-				return -1;
-			}
+	endring = ring;
 
-			for (i = 0; i < addrlen; ++i, ++p) {
-				hv = (hv << 5) ^ (hv >> 23) ^ *p;
-			}
-			hv = (hv ^ (hv >> 16));
-		}
-		for (i = 0; i < 5; ++i) {
-			CHash *ch = &CHashAry[(hv + i) & CPMHMASK];
+	for (i = 0; i <= 128; ++i)
+		if (isprint(i))
+			*endring++ = i;
+}
 
-			if (rss.ss_family == AF_INET &&
-			    ch->ch_Family == AF_INET &&
-			    sin4->sin_addr.s_addr == ch->ch_Addr4.s_addr &&
-			    ch->ch_Service && strcmp(sep->se_service,
-			    ch->ch_Service) == 0) {
-				chBest = ch;
-				break;
-			}
-#ifdef INET6
-			if (rss.ss_family == AF_INET6 &&
-			    ch->ch_Family == AF_INET6 &&
-			    IN6_ARE_ADDR_EQUAL(&sin6->sin6_addr,
-					       &ch->ch_Addr6) != 0 &&
-			    ch->ch_Service && strcmp(sep->se_service,
-			    ch->ch_Service) == 0) {
-				chBest = ch;
-				break;
-			}
-#endif
-			if (chBest == NULL || ch->ch_LTime == 0 || 
-			    ch->ch_LTime < chBest->ch_LTime) {
-				chBest = ch;
-			}
-		}
-		if ((rss.ss_family == AF_INET &&
-		     (chBest->ch_Family != AF_INET ||
-		      sin4->sin_addr.s_addr != chBest->ch_Addr4.s_addr)) ||
-		    chBest->ch_Service == NULL ||
-		    strcmp(sep->se_service, chBest->ch_Service) != 0) {
-			chBest->ch_Family = sin4->sin_family;
-			chBest->ch_Addr4 = sin4->sin_addr;
-			if (chBest->ch_Service)
-				free(chBest->ch_Service);
-			chBest->ch_Service = strdup(sep->se_service);
-			bzero(chBest->ch_Times, sizeof(chBest->ch_Times));
-		} 
-#ifdef INET6
-		if ((rss.ss_family == AF_INET6 &&
-		     (chBest->ch_Family != AF_INET6 ||
-		      IN6_ARE_ADDR_EQUAL(&sin6->sin6_addr,
-					 &chBest->ch_Addr6) == 0)) ||
-		    chBest->ch_Service == NULL ||
-		    strcmp(sep->se_service, chBest->ch_Service) != 0) {
-			chBest->ch_Family = sin6->sin6_family;
-			chBest->ch_Addr6 = sin6->sin6_addr;
-			if (chBest->ch_Service)
-				free(chBest->ch_Service);
-			chBest->ch_Service = strdup(sep->se_service);
-			bzero(chBest->ch_Times, sizeof(chBest->ch_Times));
-		}
-#endif
-		chBest->ch_LTime = t;
-		{
-			CTime *ct = &chBest->ch_Times[ticks % CHTSIZE];
-			if (ct->ct_Ticks != ticks) {
-				ct->ct_Ticks = ticks;
-				ct->ct_Count = 0;
-			}
-			++ct->ct_Count;
-		}
-		for (i = 0; i < CHTSIZE; ++i) {
-			CTime *ct = &chBest->ch_Times[i];
-			if (ct->ct_Ticks <= ticks &&
-			    ct->ct_Ticks >= ticks - CHTSIZE) {
-				cnt += ct->ct_Count;
-			}
-		}
-		if (cnt * (CHTSIZE * CHTGRAN) / 60 > sep->se_maxcpm) {
-			char pname[INET6_ADDRSTRLEN];
-
-			getnameinfo((struct sockaddr *)&rss,
-				    ((struct sockaddr *)&rss)->sa_len,
-				    pname, sizeof(pname), NULL, 0,
-				    NI_NUMERICHOST|NI_WITHSCOPEID);
-			r = -1;
-			syslog(LOG_ERR,
-			    "%s from %s exceeded counts/min (limit %d/min)",
-			    sep->se_service, pname,
-			    sep->se_maxcpm);
+/* ARGSUSED */
+static void
+chargen_stream(int s,struct servtab *sep)	/* Character generator */
+{
+	int len;
+	char *rs, text[LINESIZ+2];
+
+	inetd_setproctitle(sep->se_service, s);
+
+	if (!endring) {
+		initring();
+		rs = ring;
+	}
+
+	text[LINESIZ] = '\r';
+	text[LINESIZ + 1] = '\n';
+	for (rs = ring;;) {
+		if ((len = endring - rs) >= LINESIZ)
+			memmove(text, rs, LINESIZ);
+		else {
+			memmove(text, rs, len);
+			memmove(text + len, ring, LINESIZ - len);
 		}
+		if (++rs == endring)
+			rs = ring;
+		if (write(s, text, sizeof(text)) != sizeof(text))
+			break;
 	}
-	return(r);
 }
 
-static struct conninfo *
-search_conn(struct servtab *sep, int ctrl)
+/* ARGSUSED */
+static void
+chargen_dg(int s, struct servtab *sep)		/* Character generator */
 {
 	struct sockaddr_storage ss;
-	socklen_t sslen = sizeof(ss);
-	struct conninfo *conn;
-	int hv;
-	char pname[NI_MAXHOST],  pname2[NI_MAXHOST];
+	struct sockaddr *sa;
+	static char *rs;
+	int len;
+	socklen_t size;
+	char text[LINESIZ+2];
 
-	if (sep->se_maxperip <= 0)
-		return NULL;
+	if (endring == 0) {
+		initring();
+		rs = ring;
+	}
 
-	/*
-	 * If getpeername() fails, just let it through (if logging is
-	 * enabled the condition is caught elsewhere)
-	 */
-	if (getpeername(ctrl, (struct sockaddr *)&ss, &sslen) != 0)
-		return NULL;
+	sa = (struct sockaddr *)&ss;
+	size = sizeof(ss);
+	if (recvfrom(s, text, sizeof(text), 0, sa, &size) < 0)
+		return;
 
-	switch (ss.ss_family) {
-	case AF_INET:
-		hv = hashval((char *)&((struct sockaddr_in *)&ss)->sin_addr,
-		    sizeof(struct in_addr));
-		break;
-#ifdef INET6
-	case AF_INET6:
-		hv = hashval((char *)&((struct sockaddr_in6 *)&ss)->sin6_addr,
-		    sizeof(struct in6_addr));
-		break;
-#endif
-	default:
-		/*
-		 * Since we only support AF_INET and AF_INET6, just
-		 * let other than AF_INET and AF_INET6 through.
-		 */
-		return NULL;
-	}
+	if (!port_good_dg(sa))
+		return;
 
-	if (getnameinfo((struct sockaddr *)&ss, sslen, pname, sizeof(pname),
-	    NULL, 0, NI_NUMERICHOST | NI_WITHSCOPEID) != 0)
-		return NULL;
-
-	LIST_FOREACH(conn, &sep->se_conn[hv], co_link) {
-		if (getnameinfo((struct sockaddr *)&conn->co_addr,
-		    conn->co_addr.ss_len, pname2, sizeof(pname2), NULL, 0,
-		    NI_NUMERICHOST | NI_WITHSCOPEID) == 0 &&
-		    strcmp(pname, pname2) == 0)
-			break;
+	if ((len = endring - rs) >= LINESIZ)
+		memmove(text, rs, LINESIZ);
+	else {
+		memmove(text, rs, len);
+		memmove(text + len, ring, LINESIZ - len);
 	}
+	if (++rs == endring)
+		rs = ring;
+	text[LINESIZ] = '\r';
+	text[LINESIZ + 1] = '\n';
+	(void) sendto(s, text, sizeof(text), 0, sa, size);
+}
 
-	if (conn == NULL) {
-		if ((conn = malloc(sizeof(struct conninfo))) == NULL) {
-			syslog(LOG_ERR, "malloc: %m");
-			exit(EX_OSERR);
-		}
-		conn->co_proc = malloc(sep->se_maxperip * sizeof(*conn->co_proc));
-		if (conn->co_proc == NULL) {
-			syslog(LOG_ERR, "malloc: %m");
-			exit(EX_OSERR);
-		}
-		memcpy(&conn->co_addr, (struct sockaddr *)&ss, sslen);
-		conn->co_numchild = 0;
-		LIST_INSERT_HEAD(&sep->se_conn[hv], conn, co_link);
+/*
+ * Return a machine readable date and time, in the form of the
+ * number of seconds since midnight, Jan 1, 1900.  Since gettimeofday
+ * returns the number of seconds since midnight, Jan 1, 1970,
+ * we must add 2208988800 seconds to this figure to make up for
+ * some seventy years Bell Labs was asleep.
+ */
+
+static uint32_t
+machtime(void)
+{
+	struct timeval tv;
+
+	if (gettimeofday(&tv, NULL) < 0) {
+		if (debug)
+			fprintf(stderr, "Unable to get time of day\n");
+		return (0);
 	}
+#define	OFFSET ((uint32_t)25567 * 24*60*60)
+	return (htonl((uint32_t)(tv.tv_sec + OFFSET)));
+#undef OFFSET
+}
 
-	/*
-	 * Since a child process is not invoked yet, we cannot
-	 * determine a pid of a child.  So, co_proc and co_numchild
-	 * should be filled leter.
-	 */
+/* ARGSUSED */
+static void
+machtime_stream(int s, struct servtab *sep)
+{
+	uint32_t result;
 
-	return conn;
+	result = machtime();
+	(void) write(s, (char *) &result, sizeof(result));
 }
 
-static int
-room_conn(struct servtab *sep, struct conninfo *conn)
+/* ARGSUSED */
+void
+machtime_dg(int s, struct servtab *sep)
 {
-	char pname[NI_MAXHOST];
+	uint32_t result;
+	struct sockaddr_storage ss;
+	struct sockaddr *sa;
+	socklen_t size;
 
-	if (conn->co_numchild >= sep->se_maxperip) {
-		getnameinfo((struct sockaddr *)&conn->co_addr,
-		    conn->co_addr.ss_len, pname, sizeof(pname), NULL, 0,
-		    NI_NUMERICHOST | NI_WITHSCOPEID);
-		syslog(LOG_ERR, "%s from %s exceeded counts (limit %d)",
-		    sep->se_service, pname, sep->se_maxperip);
-		return 0;
-	}
-	return 1;
+	sa = (struct sockaddr *)&ss;
+	size = sizeof(ss);
+	if (recvfrom(s, (char *)&result, sizeof(result), 0, sa, &size) < 0)
+		return;
+	if (!port_good_dg(sa))
+		return;
+	result = machtime();
+	(void) sendto(s, (char *) &result, sizeof(result), 0, sa, size);
 }
 
+/* ARGSUSED */
 static void
-addchild_conn(struct conninfo *conn, pid_t pid)
+daytime_stream(int s,struct servtab *sep)
+/* Return human-readable time of day */
 {
-	struct procinfo *proc;
+	char buffer[256];
+	time_t clock;
+	int len;
 
-	if (conn == NULL)
+	clock = time((time_t *) 0);
+
+	len = snprintf(buffer, sizeof buffer, "%.24s\r\n", ctime(&clock));
+	(void) write(s, buffer, len);
+}
+
+/* ARGSUSED */
+void
+daytime_dg(int s, struct servtab *sep)
+/* Return human-readable time of day */
+{
+	char buffer[256];
+	time_t clock;
+	struct sockaddr_storage ss;
+	struct sockaddr *sa;
+	socklen_t size;
+	int len;
+
+	clock = time((time_t *) 0);
+
+	sa = (struct sockaddr *)&ss;
+	size = sizeof(ss);
+	if (recvfrom(s, buffer, sizeof(buffer), 0, sa, &size) < 0)
 		return;
+	if (!port_good_dg(sa))
+		return;
+	len = snprintf(buffer, sizeof buffer, "%.24s\r\n", ctime(&clock));
+	(void) sendto(s, buffer, len, 0, sa, size);
+}
 
-	if ((proc = search_proc(pid, 1)) != NULL) {
-		if (proc->pr_conn != NULL) {
-			syslog(LOG_ERR,
-			    "addchild_conn: child already on process list");
-			exit(EX_OSERR);
-		}
-		proc->pr_conn = conn;
-	}
+/*
+ * print_service:
+ *	Dump relevant information to stderr
+ */
+static void
+print_service(char *action, struct servtab *sep)
+{
 
-	conn->co_proc[conn->co_numchild++] = proc;
+	if (isrpcservice(sep))
+		fprintf(stderr,
+		    "%s: %s rpcprog=%d, rpcvers = %d/%d, proto=%s, wait.max=%d.%d, user:group=%s:%s builtin=%lx server=%s"
+#ifdef IPSEC
+		    " policy=\"%s\""
+#endif
+		    "\n",
+		    action, sep->se_service,
+		    sep->se_rpcprog, sep->se_rpcversh, sep->se_rpcversl, sep->se_proto,
+		    sep->se_wait, sep->se_max, sep->se_user, sep->se_group,
+		    (long)sep->se_bi, sep->se_server
+#ifdef IPSEC
+		    , (sep->se_policy ? sep->se_policy : "")
+#endif
+		    );
+	else
+		fprintf(stderr,
+		    "%s: %s proto=%s%s, wait.max=%d.%d, user:group=%s:%s builtin=%lx server=%s"
+#ifdef IPSEC
+		    " policy=%s"
+#endif
+		    "\n",
+		    action, sep->se_service,
+		    sep->se_type == FAITH_TYPE ? "faith/" : "",
+		    sep->se_proto,
+		    sep->se_wait, sep->se_max, sep->se_user, sep->se_group,
+		    (long)sep->se_bi, sep->se_server
+#ifdef IPSEC
+		    , (sep->se_policy ? sep->se_policy : "")
+#endif
+		    );
 }
 
 static void
-reapchild_conn(pid_t pid)
+usage(void)
 {
-	struct procinfo *proc;
-	struct conninfo *conn;
-	int i;
+#ifdef LIBWRAP
+	(void)fprintf(stderr, "usage: %s [-dl] [conf]\n", getprogname());
+#else
+	(void)fprintf(stderr, "usage: %s [-d] [conf]\n", getprogname());
+#endif
+	exit(1);
+}
 
-	if ((proc = search_proc(pid, 0)) == NULL)
-		return;
-	if ((conn = proc->pr_conn) == NULL)
-		return;
-	for (i = 0; i < conn->co_numchild; ++i)
-		if (conn->co_proc[i] == proc) {
-			conn->co_proc[i] = conn->co_proc[--conn->co_numchild];
-			break;
+
+/*
+ *  Based on TCPMUX.C by Mark K. Lottor November 1988
+ *  sri-nic::ps:<mkl>tcpmux.c
+ */
+
+static int		/* # of characters upto \r,\n or \0 */
+getline(int fd,	char *buf, int len)
+{
+	int count = 0, n;
+
+	do {
+		n = read(fd, buf, len-count);
+		if (n == 0)
+			return (count);
+		if (n < 0)
+			return (-1);
+		while (--n >= 0) {
+			if (*buf == '\r' || *buf == '\n' || *buf == '\0')
+				return (count);
+			count++;
+			buf++;
 		}
-	free_proc(proc);
-	free_conn(conn);
+	} while (count < len);
+	return (count);
 }
 
+#define MAX_SERV_LEN	(256+2)		/* 2 bytes for \r\n */
+
+#define strwrite(fd, buf)	(void) write(fd, buf, sizeof(buf)-1)
+
 static void
-resize_conn(struct servtab *sep, int maxpip)
+tcpmux(int ctrl, struct servtab *sep)
 {
-	struct conninfo *conn;
-	int i, j;
+	char service[MAX_SERV_LEN+1];
+	int len;
 
-	if (sep->se_maxperip <= 0)
-		return;
-	if (maxpip <= 0) {
-		free_connlist(sep);
-		return;
+	/* Get requested service name */
+	if ((len = getline(ctrl, service, MAX_SERV_LEN)) < 0) {
+		strwrite(ctrl, "-Error reading service name\r\n");
+		goto reject;
 	}
-	for (i = 0; i < PERIPSIZE; ++i) {
-		LIST_FOREACH(conn, &sep->se_conn[i], co_link) {
-			for (j = maxpip; j < conn->co_numchild; ++j)
-				free_proc(conn->co_proc[j]);
-			conn->co_proc = realloc(conn->co_proc,
-			    maxpip * sizeof(*conn->co_proc));
-			if (conn->co_proc == NULL) {
-				syslog(LOG_ERR, "realloc: %m");
-				exit(EX_OSERR);
-			}
-			if (conn->co_numchild > maxpip)
-				conn->co_numchild = maxpip;
+	service[len] = '\0';
+
+	if (debug)
+		fprintf(stderr, "tcpmux: someone wants %s\n", service);
+
+	/*
+	 * Help is a required command, and lists available services,
+	 * one per line.
+	 */
+	if (!strcasecmp(service, "help")) {
+		strwrite(ctrl, "+Available services:\r\n");
+		strwrite(ctrl, "help\r\n");
+		for (sep = servtab; sep != NULL; sep = sep->se_next) {
+			if (!ISMUX(sep))
+				continue;
+			(void)write(ctrl, sep->se_service,
+			    strlen(sep->se_service));
+			strwrite(ctrl, "\r\n");
 		}
+		goto reject;
 	}
+
+	/* Try matching a service in inetd.conf with the request */
+	for (sep = servtab; sep != NULL; sep = sep->se_next) {
+		if (!ISMUX(sep))
+			continue;
+		if (!strcasecmp(service, sep->se_service)) {
+			if (ISMUXPLUS(sep))
+				strwrite(ctrl, "+Go\r\n");
+			run_service(ctrl, sep);
+			return;
+		}
+	}
+	strwrite(ctrl, "-Service not available\r\n");
+reject:
+	_exit(1);
 }
 
-static void
-free_connlist(struct servtab *sep)
+#ifdef MULOG
+void
+dolog(struct servtab *sep, int ctrl)
 {
-	struct conninfo *conn;
-	int i, j;
+	struct sockaddr_storage	ss;
+	struct sockaddr		*sa = (struct sockaddr *)&ss;
+	socklen_t		len = sizeof(ss);
+	char			*host, *dp, buf[BUFSIZ];
+	int			connected = 1;
+
+	switch (sep->se_family) {
+	case AF_INET:
+#ifdef INET6
+	case AF_INET6:
+#endif
+		break;
+	default:
+		return;
+	}
 
-	for (i = 0; i < PERIPSIZE; ++i) {
-		while ((conn = LIST_FIRST(&sep->se_conn[i])) != NULL) {
-			for (j = 0; j < conn->co_numchild; ++j)
-				free_proc(conn->co_proc[j]);
-			conn->co_numchild = 0;
-			free_conn(conn);
+	if (getpeername(ctrl, sa, &len) < 0) {
+		if (errno != ENOTCONN) {
+			syslog(LOG_ERR, "getpeername: %m");
+			return;
 		}
+		if (recvfrom(ctrl, buf, sizeof(buf), MSG_PEEK, sa, &len) < 0) {
+			syslog(LOG_ERR, "recvfrom: %m");
+			return;
+		}
+		connected = 0;
+	}
+	switch (sa->sa_family) {
+	case AF_INET:
+#ifdef INET6
+	case AF_INET6:
+#endif
+		break;
+	default:
+		syslog(LOG_ERR, "unexpected address family %u", sa->sa_family);
+		return;
+	}
+
+	if (getnameinfo(sa, len, buf, sizeof(buf), NULL, 0, 0) != 0)
+		strlcpy(buf, "?", sizeof(buf));
+	host = buf;
+
+	switch (sep->se_log & ~MULOG_RFC931) {
+	case 0:
+		return;
+	case 1:
+		if (curdom == NULL || *curdom == '\0')
+			break;
+		dp = host + strlen(host) - strlen(curdom);
+		if (dp < host)
+			break;
+		if (debug)
+			fprintf(stderr, "check \"%s\" against curdom \"%s\"\n",
+			    host, curdom);
+		if (strcasecmp(dp, curdom) == 0)
+			return;
+		break;
+	case 2:
+	default:
+		break;
 	}
+
+	openlog("", LOG_NOWAIT, MULOG);
+
+	if (connected && (sep->se_log & MULOG_RFC931))
+		syslog(LOG_INFO, "%s@%s wants %s",
+		    rfc931_name(sa, ctrl), host, sep->se_service);
+	else
+		syslog(LOG_INFO, "%s wants %s",
+		    host, sep->se_service);
 }
 
+/*
+ * From tcp_log by
+ *  Wietse Venema, Eindhoven University of Technology, The Netherlands.
+ */
+#if 0
+static char sccsid[] = "@(#) rfc931.c 1.3 92/08/31 22:54:46";
+#endif
+
+#include <setjmp.h>
+
+#define	RFC931_PORT	113		/* Semi-well-known port */
+#define	TIMEOUT		4
+#define	TIMEOUT2	10
+
+static jmp_buf timebuf;
+
+/* timeout - handle timeouts */
+
 static void
-free_conn(struct conninfo *conn)
+timeout(int sig)
 {
-	if (conn == NULL)
-		return;
-	if (conn->co_numchild <= 0) {
-		LIST_REMOVE(conn, co_link);
-		free(conn->co_proc);
-		free(conn);
-	}
+	longjmp(timebuf, sig);
 }
 
-static struct procinfo *
-search_proc(pid_t pid, int add)
+/* rfc931_name - return remote user name */
+
+char *
+rfc931_name(struct sockaddr *there,	/* remote link information */
+    int ctrl)
 {
-	struct procinfo *proc;
-	int hv;
+	struct sockaddr_storage here;	/* local link information */
+	struct sockaddr_storage sin;	/* for talking to RFC931 daemon */
+	socklen_t	length;
+	int		s;
+	unsigned	remote;
+	unsigned	local;
+	static char	user[256];		/* XXX */
+	char		buf[256];
+	char		*cp;
+	char		*result = "USER_UNKNOWN";
+	int		len;
+	u_int16_t	myport, hisport;
+
+	/* Find out local port number of our stdin. */
+
+	length = sizeof(here);
+	if (getsockname(ctrl, (struct sockaddr *) &here, &length) == -1) {
+		syslog(LOG_ERR, "getsockname: %m");
+		return (result);
+	}
+	switch (here.ss_family) {
+	case AF_INET:
+		myport = ((struct sockaddr_in *)&here)->sin_port;
+		break;
+#ifdef INET6
+	case AF_INET6:
+		myport = ((struct sockaddr_in6 *)&here)->sin6_port;
+		break;
+#endif
+	}
+	switch (there->sa_family) {
+	case AF_INET:
+		hisport = ((struct sockaddr_in *)&there)->sin_port;
+		break;
+#ifdef INET6
+	case AF_INET6:
+		hisport = ((struct sockaddr_in6 *)&there)->sin6_port;
+		break;
+#endif
+	}
+	/* Set up timer so we won't get stuck. */
+
+	if ((s = socket(here.ss_family, SOCK_STREAM, 0)) == -1) {
+		syslog(LOG_ERR, "socket: %m");
+		return (result);
+	}
+
+	sin = here;
+	switch (sin.ss_family) {
+	case AF_INET:
+		((struct sockaddr_in *)&sin)->sin_port = htons(0);
+		break;
+#ifdef INET6
+	case AF_INET6:
+		((struct sockaddr_in6 *)&sin)->sin6_port = htons(0);
+		break;
+#endif
+	}
+	if (bind(s, (struct sockaddr *) &sin, sin.ss_len) == -1) {
+		syslog(LOG_ERR, "bind: %m");
+		return (result);
+	}
+
+	signal(SIGALRM, timeout);
+	if (setjmp(timebuf)) {
+		close(s);			/* not: fclose(fp) */
+		return (result);
+	}
+	alarm(TIMEOUT);
+
+	/* Connect to the RFC931 daemon. */
+
+	memcpy(&sin, there, there->sa_len);
+	switch (sin.ss_family) {
+	case AF_INET:
+		((struct sockaddr_in *)&sin)->sin_port = htons(RFC931_PORT);
+		break;
+#ifdef INET6
+	case AF_INET6:
+		((struct sockaddr_in6 *)&sin)->sin6_port = htons(RFC931_PORT);
+		break;
+#endif
+	}
+	if (connect(s, (struct sockaddr *) &sin, sin.ss_len) == -1) {
+		close(s);
+		alarm(0);
+		return (result);
+	}
 
-	hv = hashval((char *)&pid, sizeof(pid));
-	LIST_FOREACH(proc, &proctable[hv], pr_link) {
-		if (proc->pr_pid == pid)
+	/* Query the RFC 931 server. Would 13-byte writes ever be broken up? */
+	(void)snprintf(buf, sizeof buf, "%u,%u\r\n", ntohs(hisport),
+	    ntohs(myport));
+
+	for (len = 0, cp = buf; len < strlen(buf); ) {
+		int	n;
+
+		if ((n = write(s, cp, strlen(buf) - len)) == -1) {
+			close(s);
+			alarm(0);
+			return (result);
+		}
+		cp += n;
+		len += n;
+	}
+
+	/* Read response */
+	for (cp = buf; cp < buf + sizeof(buf) - 1; ) {
+		char	c;
+		if (read(s, &c, 1) != 1) {
+			close(s);
+			alarm(0);
+			return (result);
+		}
+		if (c == '\n')
 			break;
+		*cp++ = c;
 	}
-	if (proc == NULL && add) {
-		if ((proc = malloc(sizeof(struct procinfo))) == NULL) {
-			syslog(LOG_ERR, "malloc: %m");
-			exit(EX_OSERR);
+	*cp = '\0';
+
+	if (sscanf(buf, "%u , %u : USERID :%*[^:]:%255s", &remote, &local,
+	    user) == 3 && ntohs(hisport) == remote && ntohs(myport) == local) {
+		/* Strip trailing carriage return. */
+		if ((cp = strchr(user, '\r')) != NULL)
+			*cp = 0;
+		result = user;
+	}
+
+	alarm(0);
+	close(s);
+	return (result);
+}
+#endif
+
+/*
+ * check if the address/port where send data to is one of the obvious ports
+ * that are used for denial of service attacks like two echo ports
+ * just echoing data between them
+ */
+static int
+port_good_dg(struct sockaddr *sa)
+{
+	struct in_addr in;
+#ifdef INET6
+	struct in6_addr *in6;
+#endif
+	u_int16_t port;
+	int i, bad;
+	char hbuf[NI_MAXHOST];
+
+	bad = 0;
+
+	switch (sa->sa_family) {
+	case AF_INET:
+		in.s_addr = ntohl(((struct sockaddr_in *)sa)->sin_addr.s_addr);
+		port = ntohs(((struct sockaddr_in *)sa)->sin_port);
+#ifdef INET6
+	v4chk:
+#endif
+		if (IN_MULTICAST(in.s_addr))
+			goto bad;
+		switch ((in.s_addr & 0xff000000) >> 24) {
+		case 0: case 127: case 255:
+			goto bad;
 		}
-		proc->pr_pid = pid;
-		proc->pr_conn = NULL;
-		LIST_INSERT_HEAD(&proctable[hv], proc, pr_link);
+		if (dg_broadcast(&in))
+			goto bad;
+		break;
+#ifdef INET6
+	case AF_INET6:
+		in6 = &((struct sockaddr_in6 *)sa)->sin6_addr;
+		port = ntohs(((struct sockaddr_in6 *)sa)->sin6_port);
+		if (IN6_IS_ADDR_MULTICAST(in6) || IN6_IS_ADDR_UNSPECIFIED(in6))
+			goto bad;
+		if (IN6_IS_ADDR_V4MAPPED(in6) || IN6_IS_ADDR_V4COMPAT(in6)) {
+			memcpy(&in, &in6->s6_addr[12], sizeof(in));
+			in.s_addr = ntohl(in.s_addr);
+			goto v4chk;
+		}
+		break;
+#endif
+	default:
+		/* XXX unsupported af, is it safe to assume it to be safe? */
+		return (1);
 	}
-	return proc;
+
+	for (i = 0; bad_ports[i] != 0; i++) {
+		if (port == bad_ports[i])
+			goto bad;
+	}
+
+	return (1);
+
+bad:
+	if (getnameinfo(sa, sa->sa_len, hbuf, sizeof(hbuf), NULL, 0,
+	    niflags) != 0)
+		strlcpy(hbuf, "?", sizeof(hbuf));
+	syslog(LOG_WARNING,"Possible DoS attack from %s, Port %d",
+		hbuf, port);
+	return (0);
 }
 
-static void
-free_proc(struct procinfo *proc)
+/* XXX need optimization */
+static int
+dg_broadcast(struct in_addr *in)
 {
-	if (proc == NULL)
-		return;
-	LIST_REMOVE(proc, pr_link);
-	free(proc);
+	struct ifaddrs *ifa, *ifap;
+	struct sockaddr_in *sin;
+
+	if (getifaddrs(&ifap) < 0)
+		return (0);
+	for (ifa = ifap; ifa; ifa = ifa->ifa_next) {
+		if (ifa->ifa_addr->sa_family != AF_INET ||
+		    (ifa->ifa_flags & IFF_BROADCAST) == 0)
+			continue;
+		sin = (struct sockaddr_in *)ifa->ifa_broadaddr;
+		if (sin->sin_addr.s_addr == in->s_addr) {
+			freeifaddrs(ifap);
+			return (1);
+		}
+	}
+	freeifaddrs(ifap);
+	return (0);
 }
 
 static int
-hashval(char *p, int len)
+my_kevent(const struct kevent *changelist, size_t nchanges,
+    struct kevent *eventlist, size_t nevents)
+{
+	int	result;
+
+	while ((result = kevent(kq, changelist, nchanges, eventlist, nevents,
+	    NULL)) < 0)
+		if (errno != EINTR) {
+			syslog(LOG_ERR, "kevent: %m");
+			exit(EXIT_FAILURE);
+		}
+
+	return (result);
+}
+
+static struct kevent *
+allocchange(void)
 {
-	int i, hv = 0xABC3D20F;
+	if (changes == A_CNT(changebuf)) {
+		(void) my_kevent(changebuf, A_CNT(changebuf), NULL, 0);
+		changes = 0;
+	}
 
-	for (i = 0; i < len; ++i, ++p)
-		hv = (hv << 5) ^ (hv >> 23) ^ *p;
-	hv = (hv ^ (hv >> 16)) & (PERIPSIZE - 1);
-	return hv;
+	return (&changebuf[changes++]);
 }
Only in /usr/src/usr.sbin/inetd/: inetd.h
